﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.WinForms;

namespace _8918
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;

            LayerOverlay layerOverlay = new LayerOverlay();
            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\states.shp");
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Military();
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(shapeFileLayer);
            winformsMap1.Overlays.Add("layerOverlay", layerOverlay);

            InMemoryFeatureLayer circleLayer = new InMemoryFeatureLayer();
            circleLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.County1;
            circleLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add("circleLayer", circleLayer);

            shapeFileLayer.Open();
            winformsMap1.CurrentExtent = shapeFileLayer.GetBoundingBox();
            winformsMap1.Refresh();
        }

        private void winformsMap1_MapClick(object sender, MapClickWinformsMapEventArgs e)
        {
            InMemoryFeatureLayer circleLayer = (winformsMap1.Overlays["layerOverlay"] as LayerOverlay).Layers["circleLayer"] as InMemoryFeatureLayer;

            circleLayer.Clear();
            PointShape clickedPoint = e.WorldLocation;

            MultipolygonShape circle = e.WorldLocation.Buffer(50, GeographyUnit.Feet, DistanceUnit.Inch);

            circleLayer.InternalFeatures.Add(new Feature(circle));


            winformsMap1.CurrentExtent = circle.GetBoundingBox();
            winformsMap1.Refresh();
        }
    }
}
